package org.objectweb.fractal.bf.juliac.generated;

import java.util.ArrayList;
import org.osgi.framework.BundleContext;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.List;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.ow2.fractal.julia.osgi.api.control.OSGiContextController;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin
 */
public class OSGiContextControllerImpl implements Controller , Generated , OSGiContextController {
    /** 
     * @see org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin#bundleCtx
     */
    public BundleContext bundleCtx = null;
    
    /** 
     * @see org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin#setBundleContext(org.osgi.framework.BundleContext)
     */
    public void setBundleContext(final BundleContext context) {
        Component id;
        try {
            id = ((Component)(weaveableC.getFcInterface("component")));
        } catch (NoSuchInterfaceException e) {
            return ;
        }
        OSGiContextController[] occs = getOSGiContextControllers(id);
        if (occs != null) {
            for (OSGiContextController occ : occs) {
                occ.setBundleContext(context);
            }
        } 
        this.bundleCtx = context;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin#getOSGiContextControllers(org.objectweb.fractal.api.Component)
     */
    private OSGiContextController[] getOSGiContextControllers(final Component component) {
        List<org.ow2.fractal.julia.osgi.api.control.OSGiContextController>  occs = new ArrayList<org.ow2.fractal.julia.osgi.api.control.OSGiContextController> ();
        try {
            ContentController cc = org.objectweb.fractal.util.Fractal.getContentController(component);
            for (Component sub : cc.getFcSubComponents()) {
                try {
                    occs.add(((OSGiContextController)(sub.getFcInterface("osgi-context-controller"))));
                } catch (NoSuchInterfaceException e) {
                }
            }
        } catch (NoSuchInterfaceException e) {
            return null;
        }
        return occs.toArray(new OSGiContextController[occs.size()]);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$0(ic);
    }
    
    /** 
     * @see org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin#getBundleContext()
     */
    public BundleContext getBundleContext() {
        return this.bundleCtx;
    }
    
    private void initFcController$1(InitializationContext ic) throws InstantiationException {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator org.objectweb.fractal.bf.juliac.generated.OSGiContextControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.ow2.fractal.julia.osgi.control.BasicOSGiContextControllerMixin)";
    }
    
}

